<!-- markdownlint-disable MD013 MD043 MD050 -->

# OpenSSA: Neurosymbolic Agentic AI for Industrial Problem-Solving

OpenSSA is an open-source neurosymbolic agentic AI framework
designed to solve complex, high-stakes problems in industries like semiconductor, energy and finance,
where consistency, accuracy and deterministic outcomes are paramount.

At the core of OpenSSA is the [__Domain-Aware Neurosymbolic Agent (DANA)__](https://arxiv.org/abs/2410.02823) architecture,
advancing generative AI from basic pattern matching and information retrieval to industrial-grade problem solving.
By integrating domain-specific knowledge with neural and symbolic planning and reasoning,
such as __Hierarchical Task Planning (HTP)__ for structuring programs
and __Observe-Orient-Decide-Act Reasoning (OODAR)__ for executing such programs,
OpenSSA DANA agents consistently deliver accurate solutions, often using much smaller models.

## Key Benefits of OpenSSA

- __Consistent and Accurate Results__ for complex industrial problems
- __Scalable Expertise__ through AI agents incorporating deep domain knowledge from human experts
- __Economical and Efficient Computation__ thanks to usage of small models
- __Full Ownership__ of intellectual property when used with open-source models such as Llama

## Getting Started

- Install with __`pip install openssa`__ _(Python 3.12 and 3.13)_
  - For bleeding-edge capabilities: __`pip install https://github.com/aitomatic/openssa/archive/main.zip`__

- Explore the `examples/` directory and developer guides and tutorials on our [documentation site](https://aitomatic.github.io/openssa)

## [API Documentation](https://aitomatic.github.io/openssa/modules)

## Contributing

We welcome contributions from the community!

- Join discussions on our [Community Forum](https://github.com/aitomatic/openssa/discussions)
- Submit pull requests for bug fixes, enhancements and new features

For detailed guidelines, refer to our [Contribution Guide](CONTRIBUTING.md).
